`timescale 1ns / 1ps

module fgpasignal (
    input [6:0] sw,
	 input clk,
	 input set,
	 input inputpin,
	 output reg outputpin,
	 output reg [3:0] digits,
	 output reg [7:0] num,
    output reg [7:0] led
    );  
	`define lcd_1 4'b1110
	`define lcd_2 4'b1101
	`define lcd_3 4'b1011
	`define lcd_4 4'b0111
	
	reg [21:0] count,lastcount;
	reg [1:0] choosedigit;
	reg [7:0] setclk;
	initial choosedigit <=0;
	initial count <=0;
	initial lastcount <=0;
	initial led <= 8'b00000001;
	initial num <= 8'b01100000;
	wire [7:0] disp1, disp2, disp3, disp4;

	reg [15:0] originalnumber, number;
	initial number <= 16'b1111111111111111;
	initial outputpin = 0;
	initial setclk = 0;
	reg lastvalue;
	initial lastvalue = 0;
	reg[15:0] freqcount;
	initial freqcount = 0;
	reg [15:0] lastfreq;
	initial lastfreq = 0;
	reg [6:0] freqtrigger;
	initial freqtrigger = 0;
	always @(posedge clk) begin
		
		count = count +1;

		// Output 125kHz square wave on JA1
		if(setclk == 200) begin
				outputpin = ~outputpin;
				setclk = 0;
				// Detect frequency of input wave.(125kHz/freq)
				freqcount = freqcount + 1;
				if(inputpin != lastvalue) begin
					lastvalue = inputpin;
					number <= freqcount;
					freqcount = 0;
				end
		end
		setclk = setclk + 1;
		if(count >= 1000) begin
			choosedigit = choosedigit +1;
			if (choosedigit >=4) begin
					choosedigit = 0;
			end
			
			count= 0;
		end	
		// display on the LEDs
		led = choosedigit;
		case(choosedigit)
			2'b00: begin 
				num <= disp1;
				digits <= `lcd_4; end
			2'b01: begin
				num <= disp2;
				digits <= `lcd_3; end
			2'b10: begin 
				num <= disp3;
				digits <= `lcd_2; end
			2'b11: begin
				num <= disp4;
				digits <= `lcd_1; end
		endcase
	end

	

  
  getdisplay getdisp(clk, number, disp1, disp2, disp3, disp4);

endmodule

